<?php

/*
 * @package RS-MINI
 * @copyright (c) 2015 Alexey Glumov aka Rio-Shaman (support@rio-shaman.ru)
 * @license GNU General Public License version 2; see LICENSE.txt
 *
 */

if(!defined('RS-MINI')) die();

/*
 * Класс автозагрузки классов
 */

class loader
{
    
    /*
     * метод подключения классов
     * 
     * @access - private
     * 
     * @param string className - имя вызываемого класса
     */
    
    private static function loadClasses($className)
    {
        $classPath = str_replace('\\', '/', $className).'.class.php';
        
        // папки modules присутсвуют в стеке отдельно для того что бы
        // наймспейс был вида configurator\main\controller а не modules\configurator\main\controller
        // немного сокращаем запись так как неймспейсы контроллеров и шаблонов
        // бывают иногда очень длиными
        $classes = array(
            DIR_RSMINI,                // система
            DIR_PROJECT,               // проект
            DIR_RSMINI  . '/modules',  // модули системы
            DIR_PROJECT . '/modules'   // модули проекта
        );

        foreach($classes as $class) {
            $filepath = $class . '/' . $classPath;

            if (file_exists($filepath)) {
                require_once($filepath);
                return;
            }
        }       
    }
    
    /*
     * регистрирует класс и метод в стэке метода __autoload
     * 
     * @access - public
     */

    public static function register()
    {
        spl_autoload_register(array('loader', 'loadClasses'));
    }
}
